#!/usr/local/bin/perl
##################################################
#
# Update Ping ǥӥɤCGI
#
#  : ꥦ˼
#    : 2003/11/27
#
# Version: 0.91
#
#    : NDO::Weblog
#            Weblogs.Com Ping  Perl ˤ
#            http://naoya.dyndns.org/~naoya/mt/archives/000423.html
#
##################################################

# *********** ɬ **********
my($MT_DIR) = './';			# MTۡǥ쥯ȥ
my($blog_id) = "";			# ӥоBlog ID
# ***************************

unshift @INC, $MT_DIR . 'lib';
unshift @INC, $MT_DIR . 'extlib';

eval {
	require MT;
	$mt = MT->new( Config => $MT_DIR . 'mt.cfg', Directory => $MT_DIR )
		or die MT->errstr;
	
	if (!$blog_id) {
		$data = "blog_id is not specified in cgi file.";
		&error_out;
		exit;
	}

	require MT::Blog;
	$blog = MT::Blog->load($blog_id, 
                          {unique => 1});

	# rebuild indexes
    $mt->rebuild_indexes( Blog => $blog )
        or die $mt->errstr;
        
    &success_out;
};
if ($@) {
	$data = $@;
	&error_out;
	exit;
}

sub success_out {
$data = <<END_OF_DATA;
<?xml version="1.0"?>
  <methodResponse>
    <params>
      <param>
        <value>
          <struct>
            <member>
              <name>flerror</name>
              <value>
                <boolean>0</boolean>
              </value>
            </member>
          <member>
            <name>message</name>
            <value>successful ping</value>
          </member>
        </struct>
      </value>
    </param>
  </params>
</methodResponse>
END_OF_DATA

	&http_out;
}

sub error_out {
$data = <<END_OF_DATA;
<?xml version="1.0"?>
  <methodResponse>
    <params>
      <param>
        <value>
          <struct>
            <member>
              <name>flerror</name>
              <value>
                <boolean>1</boolean>
              </value>
            </member>
          <member>
            <name>message</name>
            <value>$data</value>
          </member>
        </struct>
      </value>
    </param>
  </params>
</methodResponse>
END_OF_DATA
	
	&http_out;
}

sub http_out {
	binmode(STDOUT);
	print "Content-type: text/xml; charset=euc-jp\n";
	print "Content-Length: ",length($data) ,"\n\n";
	print $data;
}
